Strict

Framework brl.glmax2d
Import brl.bmploader

Graphics 640,480,0,75

Global tileset:timage=LoadAnimImage("gfx/tileset.bmp",32,32,0,2)

SetMaskColor(255,0,255)
Global spr_snake:timage=LoadImage("gfx/snake.bmp")
Global spr_apple:timage=LoadImage("gfx/apple.bmp")

Global menu[5,15] '1=grass, 2=wall, 3=apple, 4=snake, 5savelevel, 6loadlevel, 7=newlevel, 8=quit
#menumap
DefData 0,0,0,0,0
DefData 0,1,2,3,0
DefData 0,0,0,0,0
DefData 0,4,0,0,0
DefData 0,0,0,0,0
DefData 0,9,0,10,0
DefData 0,0,0,0,0
DefData 0,5,5,5,0
DefData 0,0,0,0,0
DefData 0,6,6,6,0
DefData 0,0,0,0,0
DefData 0,7,7,7,0
DefData 0,0,0,0,0
DefData 0,8,8,8,0
DefData 0,0,0,0,0

For Local j=0 To 14
	For Local i=0 To 4
		ReadData menu[i,j]
	Next
Next

Global levelnumber:Byte=0
Global tilesize=32
Global level[15,15]
f_newlevel()

Global settile:Byte=0 '0=grass, 1=wall, 2=apple, 3=snake
Global mouserelease:Byte=1

'main loop
Repeat
	Cls
	f_drawlevel()
	f_menu()
	Flip
Until KeyHit(key_escape) Or AppTerminate()

Function f_menu()
	'drawmenu
	SetColor 50,50,50
	For Local j:Byte=0 To 14
		For Local i:Byte=0 To 4
			DrawText menu[i,j],496+i*tilesize,j*tilesize+16
		Next
	Next
	
	SetColor 255,255,255
	For Local j:Byte=0 To 14
		For Local i:Byte=0 To 4
			If menu[i,j]=1 DrawImage tileset,480+i*tilesize,j*tilesize,0
			If menu[i,j]=2 DrawImage tileset,480+i*tilesize,j*tilesize,1
			If menu[i,j]=3 DrawImage spr_apple,480+i*tilesize,j*tilesize
			If menu[i,j]=4 DrawImage spr_snake,480+i*tilesize,j*tilesize
		Next
	Next
	
	DrawText "LEVEL",530,144
	DrawText "-",530,176
	DrawText levelnumber,562,176
	DrawText "+",594,176
	
	DrawText "SAVE LEVEL",530,240
	DrawText "LOAD LEVEL",530,304
	DrawText "NEW LEVEL",530,368
	DrawText "QUIT",530,432

	'settile
	If MouseX()>480 And MouseX()<640 And MouseY()>0 And MouseY()<480
		If MouseDown(1)
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=1 Then settile=0
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=2 Then settile=1
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=3 Then settile=2
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=4 Then settile=3
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=5 Then settile=4
		EndIf
	EndIf
	
	'change map
	If MouseX()>0 And MouseX()<480 And MouseY()>0 And MouseY()<480
		If MouseDown(1)
			level[MouseX()/tilesize,MouseY()/tilesize]=settile
		EndIf
	EndIf
	
	'menu
	If mouserelease=0 And Not MouseDown(1) Then mouserelease=1
	
	If MouseX()>480 And MouseX()<640 And MouseY()>0 And MouseY()<480
		If MouseDown(1)
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=5 Then f_savelevel()
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=6 Then f_loadlevel()
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=7 Then f_newlevel()
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=8 Then End
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=9 And mouserelease
				If levelnumber>0 levelnumber:-1
				mouserelease=0
			EndIf
			If menu[(MouseX()-480)/tilesize,MouseY()/tilesize]=10 And mouserelease
				If levelnumber<9 levelnumber:+1
				mouserelease=0
			EndIf
		EndIf
	EndIf
End Function

Function f_drawlevel()
	For Local j:Byte=0 To 14
		For Local i:Byte=0 To 14
			If level[i,j]=0 DrawImage tileset,i*tilesize,j*tilesize,0
			If level[i,j]=1 DrawImage tileset,i*tilesize,j*tilesize,1
			If level[i,j]=2
				DrawImage tileset,i*tilesize,j*tilesize,0
				DrawImage spr_apple,i*tilesize,j*tilesize
			EndIf
			If level[i,j]=3
				DrawImage tileset,i*tilesize,j*tilesize,0
				DrawImage spr_snake,i*tilesize,j*tilesize
			EndIf
		Next
	Next
End Function

Function f_newlevel()
	For Local i:Byte=0 To 14
		For Local j:Byte=0 To 14
			level[i,j]=0
		Next
	Next
End Function

Function f_loadlevel()
	Local path:String="map/level" + String(levelnumber) + ".txt"
	Local file:TStream=ReadFile(path)
	For Local i:Byte=0 To 14
		For Local j:Byte=0 To 14
			level[i,j]=ReadByte(file)
		Next
	Next
	CloseFile(file)
End Function

Function f_savelevel()
	Local path:String="map/level" + String(levelnumber) + ".txt"
	Local file:TStream=WriteFile(path)
	For Local i:Byte=0 To 14
		For Local j:Byte=0 To 14
			WriteByte file,level[i,j]
		Next
	Next
	CloseFile(file)
End Function