Strict

Framework brl.glmax2d
Import brl.bmploader

Graphics 640,480,0,75

Global tileset:timage=LoadAnimImage("gfx/tileset.bmp",32,32,0,2)

SetMaskColor(255,0,255)
Global spr_snake:timage=LoadImage("gfx/snake.bmp")
Global spr_apple:timage=LoadImage("gfx/apple.bmp")

Global snakelist:TList=CreateList()

Global lifes:Byte=5
Global score=0

Global tilesize=32
Global level[15,15]
Global levelnumber:Byte=0
f_loadlevel()

'main loop
Repeat
	Cls
	f_drawlevel()
	f_update()
	Flip
Until KeyHit(key_escape) Or AppTerminate()

Type t_snake
	Field x[32]
	Field y[32]
	Field timer
	Field parts
	Field direction
	
	Function f_create(x,y)
		Local snake:t_snake= New t_snake
		For Local i:Byte=0 To 31
			snake.x[i]=x
			snake.y[i]=y
		Next
		snake.timer=100
		snake.parts=3
		snake.direction=6
		ListAddLast snakelist,snake
	End Function
	
	Method m_update()
		'move
			If KeyDown(key_left)
				direction=4
			ElseIf KeyDown(key_right)
				direction=6
			ElseIf KeyDown(key_up)
				direction=8
			ElseIf KeyDown(key_down)
				direction=2
			EndIf
		
		If timer>0
			timer:-1
		Else
			timer=10
			
			Select direction
				Case 2 y[0]:+tilesize
				Case 4 x[0]:-tilesize
				Case 6 x[0]:+tilesize
				Case 8 y[0]:-tilesize
			End Select
			
			For Local i:Byte= 0 To 30
				x[31-i]=x[30-i]
				y[31-i]=y[30-i]
			Next
		EndIf
		
		'wall collision
		If level[x[0]/tilesize,y[0]/tilesize]=1
			snakelist.remove(Self)
			If lifes>0
				lifes:-1
				f_loadlevel()
			Else
				levelnumber=0
				score=0
				lifes=5
				f_loadlevel()
			EndIf
		EndIf
		
		'apple collision
		If level[x[0]/tilesize,y[0]/tilesize]=2
			parts:+1
			score:+100
			level[x[0]/tilesize,y[0]/tilesize]=0
		EndIf
		
		'draw
		For Local i:Byte=0 To parts
			DrawImage spr_snake,x[i],y[i]
		Next
	End Method
End Type

Function f_loadlevel()
	Local path:String="map/level" + String(levelnumber) + ".txt"
	Local file:TStream=ReadFile(path)
	For Local i:Byte=0 To 14
		For Local j:Byte=0 To 14
			level[i,j]=ReadByte(file)
		Next
	Next
	CloseFile(file)
	
	For Local j=0 To 14
		For Local i=0 To 14
			If level[i,j]=3 t_snake.f_create(i*tilesize,j*tilesize)
		Next
	Next
End Function

Function f_drawlevel()
	For Local j:Byte=0 To 14
		For Local i:Byte=0 To 14
			If level[i,j]=0 DrawImage tileset,i*tilesize,j*tilesize,0
			If level[i,j]=1 DrawImage tileset,i*tilesize,j*tilesize,1
			If level[i,j]=2
				DrawImage tileset,i*tilesize,j*tilesize,0
				DrawImage spr_apple,i*tilesize,j*tilesize
			EndIf
			If level[i,j]=3 DrawImage tileset,i*tilesize,j*tilesize,0
		Next
	Next
End Function

Function f_update()
	'upadate snake
	For Local snake:t_snake=EachIn snakelist
		snake.m_update()
	Next
	
	'control level
	Local apples:Byte=0
	For Local j:Byte=0 To 14
		For Local i:Byte=0 To 14
			If level[i,j]=2 apples:+1
		Next
	Next
	If apples=0
		If levelnumber<9 levelnumber:+1 Else levelnumber=0
		
		For Local snake:t_snake=EachIn snakelist
			snakelist.remove(snake)
		Next
		
		f_loadlevel()
	EndIf
	
	'hud
	DrawText "SCORE",500,10
	DrawText score,500,20
	DrawText "LIFES",500,40
	DrawText lifes,500,50
	DrawText "LEVEL",500,70
	DrawText levelnumber,500,80
End Function